<app-loading *ngIf="isLoading"></app-loading>
<div class="app-card">
    <form nz-form [formGroup]="searchForm">
      <div nz-row [nzGutter]="[30, 0]" class="app-row">
        <div nz-col nzSm='12' nzLg="6">
          <mb-date-picker
            [mbShowTime]="true"
            mbMode="time"
            mbFormat="dd/MM/yyyy HH:mm:ss"
            [mbType]="
              isSubmitted && (searchForm.controls['fromDate'].errors || searchForm.errors?.['rangeDateError'])
                ? 'error'
                : 'default'
            "
            [mbShowError]="
              isSubmitted && (searchForm.controls['fromDate'].errors || searchForm.errors?.['rangeDateError']) != null
            "
            [mbErrors]="searchForm.errors?.['rangeDateError'] ? searchForm.errors : searchForm.controls['fromDate'].errors"
            [mbErrorDefs]="[
              {
                errorName: 'required',
                errorDescription:
                  'system.validate.required' | translate: { param: 'system.table.fromDate' | translate }
              },
              {
                errorName: 'rangeDateError',
                errorDescription:
                  'system.validate.rangeDate.pareDate'
                  | translate
                    : {
                        fromDate: 'system.table.fromDate' | translate,
                        toDate: 'system.table.toDate' | translate
                      }
              }
            ]"
            mbPlaceholderText="--{{ 'system.sessionHistory.label.attributes.fromDate' | translate }}--"
            mbLabelText="{{
              'system.sessionHistory.label.attributes.fromDate' | translate
            }} <span class='label__required'>*</span>"
            formControlName="fromDate"
          ></mb-date-picker>
        </div>
        <div nz-col nzSm='12' nzLg="6">
          <mb-date-picker
            [mbShowTime]="true"
            mbMode="time"
            mbFormat="dd/MM/yyyy HH:mm:ss"
            [mbType]="
              isSubmitted && (searchForm.controls['toDate'].errors || searchForm.errors?.['rangeDateError'])
                ? 'error'
                : 'default'
            "
            [mbShowError]="isSubmitted && searchForm.controls['toDate'].errors != null"
            [mbErrors]="searchForm.controls['toDate'].errors"
            [mbErrorDefs]="[
              {
                errorName: 'required',
                errorDescription:
                  'system.validate.required' | translate: { param: 'system.table.toDate' | translate }
              }
            ]"
            mbPlaceholderText="--{{ 'system.sessionHistory.label.attributes.toDate' | translate }}--"
            mbLabelText="{{
              'system.sessionHistory.label.attributes.toDate' | translate
            }} <span class='label__required'>*</span>"
            formControlName="toDate"
          ></mb-date-picker>
        </div>
        <div nz-col nzSm='12' nzLg="6">
          <mb-input-text
            formControlName="userName"
            [mbType]="isSubmitted && searchForm.controls['userName'].errors ? 'error' : 'default'"
            [mbMaxLength]="255"
            (mbClick)="showListUserModal()"
            [mbShowError]="isSubmitted && searchForm.controls['userName'].errors != null"
            [mbErrors]="searchForm.controls['userName'].errors"
            [mbErrorDefs]="[
              {
                errorName: 'maxlength',
                errorDescription: 'system.validate.maxLength' | translate: { numberLength: '255' }
              },
              {
                errorName: 'required',
                errorDescription:
                  'system.validate.required'
                  | translate: { param: 'system.sessionHistory.label.attributes.username' | translate }
              }
            ]"
            mbPlaceholderText="--{{ 'system.userLog.placeHolder.user' | translate }}--"
            [mbReadOnly]="true"
            mbLabelText="{{
              'system.userLog.label.user' | translate
            }} <span class='label__required'>*</span>"
          ></mb-input-text>
        </div>
        <div nz-col nzSm='12' nzLg="6">
          <div style="position: relative">
            <mb-select
              [mbDataSelects]="listScopes"
              mbKeyLabel="name"
              mbKeyValue="code"
              mbLabelText="{{ 'system.userLog.label.action' | translate }}"
              mbPlaceholder="--{{ 'system.permissionConfig.label.all' | translate }}--"
              [mbOptionHeightPx]="55"
              formControlName="scopeCodeList"
            ></mb-select>
          </div>
        </div>
        <div nz-col nzSm='12' nzLg="6">
          <mb-input-text
            formControlName="appName"
            mbPlaceholderText="--{{ 'system.userLog.placeHolder.app' | translate }}--"
            mbLabelText="{{ 'system.userLog.label.app' | translate }}"
          >
          </mb-input-text>
        </div>
        <div nz-col nzSm='12' nzLg="6">
          <mb-input-text
            formControlName="resourceName"
            mbPlaceholderText="--{{ 'system.userLog.placeHolder.function' | translate }}--"
            mbLabelText="{{ 'system.userLog.label.function' | translate }}"
          >
          </mb-input-text>
        </div>
        <div nz-col nzSm='12' nzLg="6">
          <mb-input-text
            formControlName="message"
            mbPlaceholderText="--{{ 'system.userLog.placeHolder.content' | translate }}--"
            mbLabelText="{{ 'system.userLog.label.content' | translate }}"
          >
          </mb-input-text>
        </div>
        <div nz-col nzSpan="24" class="user-log-card__left__button">
          <mb-button
            mbButtonType="NO_BORDER"
            mbButtonSize="VERY_LARGE"
            (click)="searchUserLog()"
            mbButtonAvailableStyle="SEARCH"
            mbButtonText="{{ 'system.userLog.label.search' | translate }}"
          >
          </mb-button>
        </div>
      </div>
    </form>
</div>
<div class="app-list">
  <nz-table class='data-table'
    #userLogTable
    [nzData]="listUserLog"
    [nzShowPagination]="false"
    [nzScroll]="listUserLog && listUserLog.length > 8 ? { y: '390px' } : {}"
    nzSize='small'
    [nzPageSize]='paginationCustom.size'
  >
    <thead>
      <tr class='table-header'>
        <th scope="col" class='text-nowrap text-center' nzWidth="50px" nzLeft='0'>{{ 'system.userLog.table.label.stt' | translate }}</th>
        <th scope="col" class='text-nowrap'>{{ 'system.userLog.table.label.time' | translate }}</th>
        <th scope="col" class='text-nowrap'>{{ 'system.userLog.table.label.user' | translate }}</th>
        <th scope="col" class='text-nowrap'>{{ 'system.userLog.table.label.action' | translate }}</th>
        <th scope="col" class='text-nowrap'>{{ 'system.userLog.table.label.app' | translate }}</th>
        <th scope="col" class='text-nowrap'>{{ 'system.userLog.table.label.function' | translate }}</th>
        <th scope="col" class='text-nowrap'>{{ 'system.userLog.table.label.content' | translate }}</th>
      </tr>
    </thead>
    <tbody>
      <tr *ngFor="let data of userLogTable.data; let i = index;  trackBy: trackByFn" class='row-table'>
        <td nzWidth="50px" nzLeft='0' class='text-nowrap text-center'>{{ i + 1 + paginationCustom.size * paginationCustom.pageIndex }}</td>
        <td>{{ data.dateTime | date: 'dd/MM/yyyy HH:mm:ss' }}</td>
        <td>{{ data.userName }}</td>
        <td>{{ data.scopeName }}</td>
        <td>{{ data.appName }}</td>
        <td>{{ data.resourceName }}</td>
        <td>{{ data.msgContents }}</td>
      </tr>
    </tbody>
  </nz-table>
</div>
<div class="pagination" *ngIf='listUserLog && listUserLog.length > 0'>
  <div class="pagination__table-info">
    <img class="pagination__table-info--icon" alt="" src="assets/images/icon/idea.svg" />
    <span class="pagination__table-info--text">
      Tìm thấy {{ paginationCustom.total }} kết quả, hiển thị từ
      {{ paginationCustom.size * paginationCustom.pageIndex + 1 }} đến
      {{ paginationCustom.size * paginationCustom.pageIndex + paginationCustom.numberOfElements }}</span
    >
  </div>
  <nz-pagination
    [nzPageIndex]="paginationCustom.pageIndex + 1"
    (nzPageIndexChange)="changePage($event)"
    [nzTotal]="paginationCustom.total"
    [nzPageSize]="paginationCustom.size"
  ></nz-pagination>
</div>
